* ------------------------------------------------------ *
* SISTEMA     :                                          *
* PRG         :                                          *
* CREADO      :                                          *
* ACTUALIZADO :                                          *
* AUTOR       :                                          *
* COMENTARIOS :                                          *
* ------------------------------------------------------ *

#include <minigui.ch>

FUNCTION MAIN

   DEFINE WINDOW Win_1;
      AT 0,0 ;
      WIDTH 640 HEIGHT 460 ;
      TITLE 'Consulta CPE' ;
      ON INIT INISETS() ;
      MAIN

      DEFINE MAIN MENU
         POPUP "&Operaciones"
            ITEM '&1. Firmar XML'                  ACTION CPE_Sign()
         END POPUP
      END MENU

//
// BARRA DE ESTADO
//
      DEFINE STATUSBAR
         STATUSITEM "..."
         CLOCK WIDTH 70
         DATE  WIDTH 90
      END STATUSBAR

   END WINDOW

   CENTER WINDOW Win_1
   ACTIVATE WINDOW Win_1

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION...: INISETS
* COMENTARIO: INICIALIZA LOS SETEOS DEL SISTEMA.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC INISETS

SET BELL       Off
SET CONSOLE    Off
SET CURSOR     Off
SET DATE TO BRIT
SET DELETED    On
SET DELIMITERS Off
SET ECHO       Off
SET EPOCH TO 1990
SET MESSAGE TO 22 CENTER
SET SAFETY     Off
SET SCOREBOARD Off
SET TALK       Off
SET WRAP       On
ALTD(0)

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC CPE_Sign

   XML_Sign( '20600992571-01-F001-00000001.xml' , 'CERT-DEMO.crt' , 'saludyvida' , 'F001-00000001-Firmado.xml' )

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC XML_Sign( tcRutaFileXML , tcRutaFileCertificado , tcPasswordCertificado , tcRutaFileXMLSalida )

LOCAL oErr
LOCAL loFirmaE
LOCAL llError := .F.
LOCAL llOk    := .F.

IF EMPTY(tcRutaFileCertificado) .OR. VALTYPE(tcRutaFileCertificado) <> "C" 
	msginfo("Ingrese el Certificado a usar para la firma.")
	RETURN .F.
ENDIF 
IF EMPTY(tcPasswordCertificado) .OR. VALTYPE(tcPasswordCertificado) <> "C" 
	msginfo("Ingrese el PassWord del Certificado.")
	RETURN .F.
ENDIF
IF EMPTY(tcRutaFileXML) .OR. VALTYPE(tcRutaFileXML) <> "C" 
	msginfo("Ingrese el XML a firmar.")
	RETURN .F.
ENDIF
IF EMPTY(tcRutaFileXMLSalida) .OR. VALTYPE(tcRutaFileXMLSalida) <> "C" 
	msginfo("Ingrese la Ruta y Nombre del XML para la Salida")
	RETURN .F.
ENDIF 

BEGIN SEQUENCE
	loFirmaE := CreateObject("DotNetFirmaXmlDSigPE.FirmaXmlDSigPE")
RECOVER USING oError
	llError := .T.
   MsgStop(oError:Operation+CRLF+oError:Description,"ERROR DLL")
END SEQUENCE

IF ! llError 
   IF loFirmaE:FirmarXML(tcRutaFileXML, tcRutaFileCertificado, tcPasswordCertificado, tcRutaFileXMLSalida)
      llOk := .T.
   ENDIF
ENDIF

RETURN( llOk )
